#include <iostream>
#include <vector>

using namespace std;

struct plane
{
	vector<vector<bool>> points;
	int centerX = 0;
	int centerY = 0;
	unsigned sizeX = 1;
	unsigned sizeY = 1;

	enum Dir {
		RIGHT, UP, LEFT, DOWN
	};

	plane() : points(1, vector<bool>(1, false)) {}

	void set(int x, int y, bool b = true) {
		x += centerX;
		y += centerY;
		if (x < 0) {
			this->expand(LEFT);
			++x;
		} else if (x >= sizeX) {
			this->expand(RIGHT);
		}
		if (y < 0) {
			this->expand(DOWN);
			++y;
		} else if (y >= sizeY) {
			this->expand(UP);
		}
		points[x][y] = b;
	}

	void expand(Dir d) {
		switch (d) {
		case RIGHT:
		case LEFT:
			sizeX++;
			points.push_back(vector<bool>(sizeY, false));
			break;
		case UP:
		case DOWN:
			sizeY++;
			for (auto &e : points) {
				e.push_back(false);
			}
			break;
		}
		if (d == LEFT) {
			++centerX;
			for (size_t i = sizeX - 1; i > 0; --i) {
				for (size_t j = 0; j < sizeY; ++j) {
					points[i][j] = points[i - 1][j];
					if (i == 1) {
						points[i - 1][j] = false;
					}
				}
			}
		}
		if (d == DOWN) {
			++centerY;
			for (size_t i = 0; i < sizeX; ++i) {
				for (size_t j = sizeY - 1; j > 0; --j) {
					points[i][j] = points[i][j - 1];
					if (j == 1) {
						points[i][j - 1] = false;
					}
				}
			}
		}

	}
};

int main(int argc, char* argv[])
{
	unsigned n, d, k;
	cin >> n >> d >> k;

	auto p = plane();
	plane::Dir dir = plane::RIGHT;
	int posX = 0, posY = 0;

	unsigned _i = 0;
	for (size_t i = 0; i <= n; ++i) {
		p.set(posX, posY, true);
		if (i - _i == d) {
			if (dir == plane::UP || dir == plane::DOWN) {
				d *= k;
			}
			_i = i;
			switch (dir) {
			case plane::RIGHT:
				dir = plane::UP;
				break;
			case plane::UP:
				dir = plane::LEFT;
				break;
			case plane::LEFT:
				dir = plane::DOWN;
				break;
			case plane::DOWN:
				dir = plane::RIGHT;
				break;
			}
		}
		switch (dir) {
		case plane::RIGHT:
			++posX;
			break;
		case plane::UP:
			++posY;
			break;
		case plane::LEFT:
			--posX;
			break;
		case plane::DOWN:
			--posY;
			break;
		}
	}

	cout << p.sizeX << " " << p.sizeY << endl;

	for (int j = p.sizeY - 1; j >= 0; --j) {
		for (size_t i = 0; i < p.sizeX; ++i) {
			cout << (p.points[i][j] ? '*' : '.');
		}
		cout << endl;
	}

	cin.get(); cin.get();
	return 0;
}