import javafx.util.Pair;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.nio.channels.InterruptedByTimeoutException;
import java.util.*;

public class E {
    StringTokenizer st;
    BufferedReader br;
    PrintWriter pw;

    private static long gcd(long a, long b) {
        long c = Math.max(a, b);
        long d = Math.min(a, b);
        while (c * d > 0) {
            c %= d;
            long t = d;
            d = c;
            c = t;
        }
        return c + d;
    }

    private void run() throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int n = nextInt();
        int k = nextInt();
        long[] a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextLong();
        }
        long curNOD = 0;
        long maxNOD = 1;
        for (int i = 0; i < n - k; i++) {
            curNOD = a[i];
            for (int j = i + 1; j < i + k; j++) {
                curNOD = gcd(curNOD, a[j]);
                if (curNOD == 1) {
                    i = j;
                    break;
                }
            }
            maxNOD = Math.max(curNOD, maxNOD);
        }

        pw.print(maxNOD);
        pw.close();

    }

    public String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new E().run();
    }

}
