#include <iostream>
#include <vector>

using namespace std;

vector<pair<int, int> > result;
pair<int, int> step(int x, int y, int* dir, int dest, int d) {
    int xStep = dir[2 * dest];
    int yStep = dir[2 * dest + 1];
    for (int i = 0; i < d; i++) {
        x += xStep;
        y += yStep;
        result.push_back(make_pair<int, int>(x, y));
    }
    return make_pair<int, int>(x, y);
}

int main(void) {
    int n, d, k;
    int p[] = {1, 0, 0, -1, -1, 0, 0, 1};
    int* dir = p;
    result.push_back(make_pair<int, int>(0, 0));
    cin >> n >> d >> k;

    int x = 0, y = 0, dest = 0;
    while (n > 0) {
        pair<int, int> nxy = step(x, y, dir, dest, min(d, n));
        n -= d;
        x = nxy.first;
        y = nxy.second;
        dest += 1;
        dest %= 4;
        if (n > 0) {
            nxy = step(x, y, dir, dest, min(d, n));
            n -= d;
            x = nxy.first;
            y = nxy.second;
            dest += 1;
            dest %= 4;
        }

        d *= k;
    }
    int min_x = 1000000000, min_y = 1000000000, max_x = -1000000000, max_y = -1000000000;
    for (int i = 0; i < result.size(); i++) {
        pair<int, int> current = result[i];
        x = current.first;
        y = current.second;
        min_x = min(min_x, x);
        min_y = min(min_y, y);
        max_x = max(max_x, x);
        max_y = max(max_y, y);
    }
    int h = max_y - min_y + 1, w = max_x - min_x + 1;
    bool** steps = new bool*[h];
    for (int i = 0; i < h; i++)
        steps[i] = new bool[w];
    for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            steps[i][j] = false;
    for (int i = 0; i < result.size(); i++) {
        pair<int, int> current = result[i];
        x = current.first;
        y = current.second;
        steps[y - min_y][x - min_x] = true;
    }
    cout << h << " " << w << endl;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (steps[i][j])
                cout << "*";
            else
                cout << ".";
        }
    cout << endl;
    }
    return 0;
}
