import java.io.*;
import java.util.*;

public class B {

    public long n;

    public boolean check(long cnt) {
        long need = 0;
        for (long i = 1; i <= cnt; i++) {
            need += i * i;
            if (need > n)
                return false;
        }
        return need <= n;
    }

    public void solve() throws IOException {
        n = nextLong();
        long l = 0;
        long r = (int) 1e9;
        while (r - l > 1) {
            long m = (r + l) / 2;
            if (check(m))
                l = m;
            else
                r = m;
        }
        out.print(l);
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }
}