

import java.io.*;
import java.util.*;

public class C {

    public long n, d, k;

    public long i = 0, j = 0;
    public long dI = 0, dJ = 1;
    int cnt = 0;

    public void rotate() {
        long tmpDi = dI;
        dI = -dJ;
        dJ = tmpDi;
    }

    public static class Cell {
        public long i, j;

        public Cell(long i, long j) {
            this.i = i;
            this.j = j;
        }
    }

    public List<Cell> cells;

    public void move() {
        if (cnt == n)
            return;
        i += dI;
        j += dJ;
        cells.add(new Cell(i, j));
        cnt++;
    }

    public void solve() throws IOException {
        n = nextLong();
        d = nextLong();
        k = nextLong();
        cells = new ArrayList<Cell>((int) n);
        cells.add(new Cell(0, 0));
        while (cnt != n) {
            for (int i = 0; i < d; i++) {
                move();
            }
            rotate();
            for (int i = 0; i < d; i++) {
                move();
            }
            rotate();
            d *= k;
        }
        int minI = 0;
        int minJ = 0;
        for (int i = 0; i < cells.size(); i++) {
            Cell cell = cells.get(i);
            minI = (int) Math.min(minI, cell.i);
            minJ = (int) Math.min(minJ, cell.j);
        }
        for (int i = 0; i < cells.size(); i++) {
            Cell cell = cells.get(i);
            cell.i += Math.abs(minI);
            cell.j += Math.abs(minJ);
        }
        int maxI = 0;
        int maxJ = 0;
        for (int i = 0; i < cells.size(); i++) {
            Cell cell = cells.get(i);
            maxI = (int) Math.max(maxI, cell.i);
            maxJ = (int) Math.max(maxJ, cell.j);
        }
        boolean[][] map = new boolean[maxI + 1][maxJ + 1];
        for (int i = 0; i < cells.size(); i++) {
            Cell cell = cells.get(i);
            map[((int) cell.i)][((int) cell.j)] = true;
        }
        out.print(maxI + 1);
        out.print(' ');
        out.println(maxJ + 1);
        for (int i = 0; i < maxI + 1; i++) {
            for (int j = 0; j < maxJ + 1; j++) {
                if (map[i][j]) {
                    out.print('*');
                } else {
                    out.print('.');
                }
            }
            out.println();
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new C().run();
    }
}