import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class E {

    public long gcd(long a, long b) {
        if (a == -1)
            return b;
        else if (b == -1)
            return a;
        while (b != 0) {
            long r = a % b;
            a = b;
            b = r;
        }
        return a;
    }

    public int n, k;

    public long[] a;

    public static class Node {
        public int l, r;

        public long gcd;

        public Node left, right;

        public Node(int l, int r) {
            this.l = l;
            this.r = r;
        }
    }

    public Node build(int l, int r) {
        Node res = new Node(l, r);
        if (l != r) {
            int m = (l + r) / 2;
            res.left = build(l, m);
            res.right = build(m + 1, r);
            res.gcd = gcd(res.left.gcd, res.right.gcd);
        } else {
            res.gcd = a[l];
        }
        return res;
    }

    public long query(Node root, int l, int r) {
        if (r < root.l || l > root.r)
            return -1;
        if (root.l >= l && root.r <= r) {
            return root.gcd;
        }
        return gcd(query(root.left, l, r), query(root.right, l, r));
    }

    public void solve() throws IOException {
        n = nextInt();
        k = nextInt();
        a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextLong();
        }
        Node root = build(0, n - 1);
        long ans = 1;
        for (int l = 0; l <= n - k; l++) {
            ans = Math.max(ans, query(root, l, l + k - 1));
        }
        out.print(ans);
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new E().run();
    }
}