import java.io.*;
import java.util.*;

public class F {

    public Set<Integer> allowed[];

    public void solve() throws IOException {
        int k = nextInt();
        int n = nextInt();
        allowed = new Set[26];

        for (int i = 0; i < 26; i++) {
            allowed[i] = new HashSet<Integer>();
        }
        for (int i = 0; i < n; i++) {
            String tmp = nextToken();
            allowed[tmp.charAt(0) - 'a'].add(tmp.charAt(1) - 'a');
            allowed[tmp.charAt(1) - 'a'].add(tmp.charAt(0) - 'a');
        }
        int[] cnt1 = new int[k];
        int[] cnt2 = new int[k];
        String s = nextToken();
        String t = nextToken();
        if (s.equals(t)) {
            out.print("YES");
            return;
        }
        int[][] lower1 = new int[k][k];
        int[][] lower2 = new int[k][k];
        for (int i = 0; i < s.length(); i++) {
            for (int j = 0; j < k; j++) {
                lower1[s.charAt(i) - 'a'][j] += cnt1[j];
                lower2[t.charAt(i) - 'a'][j] += cnt2[j];
            }
            cnt1[s.charAt(i) - 'a']++;
            cnt2[t.charAt(i) - 'a']++;
        }
        for (int i = 0; i < k; i++) {
            if (cnt1[i] != cnt2[i]) {
                out.print("NO");
                return;
            }
        }
        for (int i = 0; i < k; i++) {
            for (int j = 0; j < k; j++) {
                if (!allowed[i].contains(j) && lower1[i][j] != lower2[i][j]) {
                    out.print("NO");
                    return;
                }
            }
        }
        out.print("YES");
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new F().run();
    }
}