#include <cmath>
#include <cstdio>
#include <conio.h>
#include <vector>

enum Dir
{
	Right = 0, Up = 1, Left = 2, Down = 3
};

struct Point
{
	int x, y;
};

void SwapDir(Dir &d, Point &coefs, int n)
{
	if (d == Down || d == Up)
		coefs = {coefs.y * -1, coefs.x * -1};
	else
    	coefs = { coefs.y, coefs.x};

	d = (Dir)((d + n) % 4);
	if (d < 0)
		d = (Dir)(4 + (d % 4));
}

int main(void)
{
	int n, d, k;
	Dir dir = Right;
	Point CurP, DirCoefs = { 0, 0 };

	bool IsHalfStep = false;
	scanf("%i", &n);	
	scanf("%i", &d);
	scanf("%i", &k);
	std::vector<std::vector<int>> field;
	
	int size = d + 1, nn = n, dd = d;
	
	while (1)
	{
		nn -= 2 * dd;		
		SwapDir(dir, DirCoefs, 2);
		//dir = (Dir)((dir + 2) % 4);
		if (nn < 2 * dd)
		{
			if (nn >= dd)
			{
				IsHalfStep = true;
				size += dd * k - dd;
				SwapDir(dir, DirCoefs, 1);
				//dir = (Dir)((dir + 1) % 4);
			}
			break;
		}
		size += dd * k - dd;
		dd *= k;
	}
	
	field.resize(size);
	for (int i = 0; i < size; i++)
		field[i].resize(size);

	if (dir == Right)
	{
		CurP = { nn, size - 1 };
		DirCoefs = { -1, 0 };
	}
	if (dir == Up)
	{
		CurP = { size - 1, size - nn - 2 };
		DirCoefs = { 0, 1 };
	}
	if (dir == Left)
	{
		CurP = { size - (2 + nn), 0 };
		DirCoefs = { 1, 0 };
	}
	if (dir == Down)
	{
		CurP = { 0, nn };
		DirCoefs = { 0, -1 };
	}
	
	for (int i = 0; i < nn + 1; i++)
	{
	   field[CurP.x + i * DirCoefs.x][CurP.y + i * DirCoefs.y] = true;
	}
	CurP = { CurP.x + nn * DirCoefs.x, CurP.y + nn * DirCoefs.y };
	SwapDir(dir, DirCoefs , -1);
	size -= 1;
	if (IsHalfStep)
	{
		for (int i = 1; i < size + 1; i++)
			field[CurP.x + i * DirCoefs.x][CurP.y + i * DirCoefs.y] = true;
		SwapDir(dir, DirCoefs, -1);
		size -= dd - dd / k;
		dd /= k;
	}
	int finalsize = size;
	while (size >= d)
	{
		for (int i = 1; i < size + 1; i++)
			field[CurP.x + i * DirCoefs.x][CurP.y + i * DirCoefs.y] = true;
		CurP = { CurP.x + size * DirCoefs.x, CurP.y + size * DirCoefs.y };
		SwapDir(dir, DirCoefs, -1);
		for (int i = 1; i < size + 1; i++)
			field[CurP.x + i * DirCoefs.x][CurP.y + i * DirCoefs.y] = true;
		CurP = { CurP.x + size * DirCoefs.x, CurP.y + size * DirCoefs.y };
		SwapDir(dir, DirCoefs, -1);
		size -= dd - dd / k;
		dd /= k;
	}

	for (int i = 0; i < finalsize + 1; i++)
	{
		for (int j = 0; j < finalsize + 1; j++)
			if (field[j][i])
				printf("*");
			else
				printf(".");
		printf("\n");
	}

	_getch();
	return 0;
}